--
-- slice modeller V1.0 alpha
--
-- copyright 2011 xoio, peter stulz, lasse rode
--

clearListener()
try(destroyDialog xoioSliceModeller) catch()

Objectname ="O_Kiste_01"
SliceCounter=0
gridarray = #()
geomarray = #()
currentg = 0

				
				
	
rollout XoioSliceModeller "xoioSliceModeller v1.0 alpha" width:504 height:264
(
	
	label LabelBoxSize "Box Size:" pos:[24,50] width:56 height:16
	spinner SpinBoxWidth "width: " pos:[140,70] width:50 height:16 range:[0,100,10]
	spinner SpinBoxLength "length: " pos:[52,70] width:55 height:16 range:[0,100,10]
	spinner SpinBoxHeight "height: " pos:[225,70] width:55 height:16 range:[0,100,10]
	checkbox CheckSym "Use Symmetry" pos:[24,120] width:100 height:32 enabled:true checked:true
	editText ObjectName "Object Name:" pos:[24,100] width:255 height:24 text:"O_SliceModell_01" enabled:true
	button StartButton "Create Geometry" pos:[24,154] width:255 height:24
	button HelpButton "Help" pos:[160,14] width:120 height:24 enabled:true
	button AboutButton "About" pos:[22,14] width:120 height:24 enabled:true
	button ButtonNextSlice "Slice Me!" pos:[24,178] width:255 height:56
	button ButtonBakeModell "Bake Model" pos:[24,234] width:255 height:64 enabled:true
	
	
	
	---functions
	
	fn slice getit = (SliceCounter=SliceCounter+1
				recSlname = "slice" + Slicecounter as string
				--get selection boundingbox for calculating dimensions
				bb = nodeLocalBoundingBox $
				bbva = bb[1]
				bbvb = bb[2]
				w = bbvb[1]-bbva[1]
				l = bbvb[2]-bbva[2]
				h = bbvb[3]-bbva[3]
				xgrid=(((bbvb[1]-bbva[1])/2)+bbva[1])

	
				sbody = $
				
				addModifier $ (SliceModifier ()) ui:on
				
				
				possp= [0,0,h/2]
				sbody.modifiers[#slice].name = recSlname
				sbody.modifiers[recSlname].Slice_Type = 2
				sbody.modifiers[recSlname].Slice_Plane.position = possp
				-- Add Cap-Modifier
				addModifier $ (Cap_Holes ()) ui:on
				
				addModifier $ (smooth ()) ui:on
				if checksym.state == true then(
					addModifier $ (Symmetry ()) ui:on)
				
				ditteposition = sbody.pos
				difx = ditteposition[1] as string
					difz = ditteposition[3]
				-- Create Grid
	
							
				Gridname = Objectname.text + "_Helper_" + SliceCounter as string
				Gridhelper = grid length:(l*1.5) width:(w*1.5) grid:10 pos:[(((bbvb[1]-bbva[1])/2)+bbva[1]),(((bbvb[2]-bbva[2])/2)+bbva[2]),(h/2+difz)] isSelected:on gridcolor:random
				gridhelper.wirecolor = (color (random 0 255) (random 0 255) (random 0 255))
				Gridhelper.name = Gridname
				Gridhelper.parent = sbody

				append gridarray gridhelper
				append geomarray sbody
				currentg = currentg + 1
				paramWire.connect2way Gridhelper.transform.controller[#Position] sbody.modifiers[recSlname].Slice_Plane.controller[#Position]  "Position" "Position"
				paramWire.connect2way Gridhelper.transform.controller[#Rotation]sbody.modifiers[recSlname].Slice_Plane.controller[#Rotation]  "Rotation" "Rotation"
				


				select gridhelper)
	----EVENTS
		
	on StartButton pressed do
	(
		
	
		
		Kiste = Box lengthsegs:1 widthsegs:1 heightsegs:1 length:SpinBoxlength.value width:SpinBoxWidth.value height:SpinBoxheight.value mapcoords:on realWorldMapSize:off pos:[0,0,0] isSelected:on
		Kiste.name = ObjectName.text
		Skulpur = Kiste 
	)
	
	on ButtonNextSlice pressed do
	(
		if superclassof $ != Geometryclass then 
			(
				if superclassof $ == Helper then
					(
						if $.parent != undefined and superclassof $.parent == Geometryclass then 
						(
						select $.parent
						slice getit
						)
					)
				)
			
		else  
		(
		slice getit
		)
		
	)
	on ButtonBakeModell pressed do
	(
	--select geomarray
	if superclassof $ == Geometryclass then
		(
		convertto $ editable_poly
		if $.children != undefined then
			(
			delete $.children
			)
		)
	if superclassof $ == Helper then
		(
		if $.parent != undefined then
			(
			pargeom = $.parent
			childgrid = pargeom.children
			convertto pargeom editable_poly
			delete childgrid
			)
		
		)
		
	
	gridarray = #()
	geomarray = #()	
	)
	
	on AboutButton pressed do
	(
	messagebox "slice modeller V1.0 alpha, copyright 2011 xoio, peter stulz, lasse rode"
	)
	
	on HelpButton pressed do 
		(
		a1="1. Define the dimensions of the box you want to start out with and press the start-modelling-new-button or select your already created starting geometry. \r\n"
		a2="2. Press the next-slice-button.\r\n"
		a3="3. Modify your geometry by moving the grid-helpers.\r\n"
		a4="4. To apply a new slice-modifier select your geometry and press the next-slice-button again.\r\n"
		a5="5. To collapse the modifier stack, do it manually or press the bake-modell-button. The geometry will be transformed to an Editable Poly object and the helpers will be deleted.\r\n"
				
		x = a1+a2+a3+a4+a5 --+a8+a9+a10+a11
		messagebox x
		)
)
		
		
		
createDialog XoioSliceModeller width:300 height:310
	
	
	

	